<template src="./editInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import SelectComponent from '../../../../../inputs/SelectComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('select-component', SelectComponent);

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseProductStoreObject());
        },

        data() {

            return {

                baseInfo: {

                    name: '',

                    slug: '',

                    description: '',

                    active: false,

                    brand_id: null,

                    price_note: '',

                    height: '',

                    width: '',

                    weight: '',

                    length: '',

                    thickness: '',
                },

                productCategories: [

                    { id: null }
                ],

                slugTimeout: null
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Parse Product from store after event.
             **/
            parseProductStoreObject() {

                let product = this.$store.state.product;

                this.baseInfo = product.base_info;

                this.productCategories = product.categories.map( (el) => {

                    return { id: el.id };
                })
            },

            /**
             * Remove given category.
             *
             * @param index
             */
            removeProductCategory(index) {

                this.productCategories.splice(index, 1);
            },


            /**
             * Add empty category.
             */
            addProductCategory() {

                this.productCategories.push({ id: null });
            },


            /**
             * Suggest initial slug.
             *
             * @param name
             */
            createInitialSlugFromName(name) {

                clearTimeout(this.slugTimeout);

                this.slugTimeout = setTimeout( () => {

                    if (this.baseInfo.slug === '') {

                        this.baseInfo.slug = name.replace(' ', '-').toLowerCase();
                    }

                }, 500);
            }
        },

        computed: {

            /**
             * Data for brands select from store getter.
             **/
            selectBrandsList() {

                return this.$store.getters.selectBrands;
            },


            /**
             * Data for categories select from store getter.
             **/
            selectCategoriesList() {

                return (index) => {

                    return this.$store.getters.selectCategories.filter( (el) => {

                        return ! this.productCategories.find( (c) => {

                                return c.id == el.value;

                            }) || this.productCategories[index].id == el.value;
                    });
                };
            },


            /**
             * If there is empty category or every available category is selected
             * do not give right to add another.
             *
             * @returns {T}
             */
            disabledAddButton() {

                return this.productCategories.find( (el) => el.id === null);
            },

            /**
             * If every available category is selected hide add button.
             */
            showAddButton() {

                return this.$store.getters.selectCategories.length > this.productCategories.length;
            }
        },

        watch: {

            'baseInfo.name'(newName) {

                this.createInitialSlugFromName(newName);
            },


            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setProductBaseInfo', newBaseInfo);
                },

                deep: true
            },


            /**
             * Push array of product categories ids to store.
             */
            productCategories: {

                handler(newProductCategories) {

                    /**
                     * Filter categories where id not null and then push array of ids.
                     */
                    this.$store.dispatch('setProductCategories', newProductCategories.filter( (el) => el.id !== null).map( (el) => el.id));
                },

                deep: true
            }
        }
    }

</script>